<template>
  <div class="section">
    <div class="container">
      <h1 class="title">Users</h1>
      <hr>
      <b-field label="Find a User">
        <b-autocomplete
          :data="allUsers"
          placeholder="e.g. Travis"
          field="title"
          :loading="$apollo.loading"
          @select="option => $router.push(`/users/${option.username}`)">

          <template slot-scope="props">
            <div class="media">
              <div class="media-left">
                <img width="42" :src="profileImageUrl(props.option.profileImage)" :alt="`${props.option.firstname} ${props.option.lastname}`">
              </div>
              <div class="media-content">
                {{ props.option.firstname }} {{ props.option.lastname }}&nbsp; <small>@{{ props.option.username}}</small>
                <br>
                <small>
                  {{ props.option.bio }}
                </small>
              </div>
            </div>
          </template>
        </b-autocomplete>
      </b-field>
      <div class="container">
        <div class="box" v-for="user in allUsers" :key="user.id">
          <article class="media">
            <div class="media-left">
              <figure class="image is-64x64">
                <img :src="profileImageUrl(user.profileImage)" :alt="`${user.firstname} ${user.lastname}`">
              </figure>
            </div>
            <div class="media-content">
              <router-link :to="`/users/${user.username}`" class="button is-primary is-outlined is-pulled-right">View Profile</router-link>
              <div class="content">
                <p>
                  <router-link :to="`/users/${user.username}`">
                    <strong>{{ user.firstname }} {{ user.lastname }}</strong>&nbsp;&nbsp;<small>@{{ user.username }}</small>
                  </router-link>
                  <br>
                  {{ user.bio }}
                </p>
              </div>
              <nav class="level is-mobile">
                <div class="level-left">
                  <a class="level-item" aria-label="reply">
                    <span class="icon is-small">
                      <i class="fas fa-reply" aria-hidden="true"></i>
                    </span>
                  </a>
                  <a class="level-item" aria-label="retweet">
                    <span class="icon is-small">
                      <i class="fas fa-retweet" aria-hidden="true"></i>
                    </span>
                  </a>
                  <a class="level-item" aria-label="like">
                    <span class="icon is-small">
                      <i class="fas fa-heart" aria-hidden="true"></i>
                    </span>
                  </a>
                </div>
              </nav>
            </div>
          </article>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import ALL_USERS_QUERY from '@/graphql/User/AllUsers.gql'
export default {
  apollo: {
    allUsers: {
      query: ALL_USERS_QUERY
    }
  },
  methods: {
    profileImageUrl (path) {
      return `${this.$store.state.cloudinary}/w_80,h_80,c_thumb,g_face,f_auto,q_auto/${path}`
    }
  }
}
</script>
